Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/include/Allocation.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/include/Allocation.h	(revision 127)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/include/Allocation.h	(revision 128)
@@ -15,80 +15,110 @@
 // ======================================================================
 #define ALLOC0(var,type)                        \
-  var = new type
-
-#define ALLOC1(var,type,s1)                      \
-  var = new type [s1]
-  
+  do                                            \
+    {                                           \
+      var = new type;                           \
+    } while (0)
+
+#define ALLOC1(var,type,s1)                     \
+  do                                            \
+    {                                           \
+      var = new type [s1];                      \
+    } while (0)
+
 #define ALLOC2(var,type,s1,s2)                   \
-  var = new type * [s1];                         \
-  for (uint32_t it1=0; it1<s1; ++it1)            \
+  do                                             \
     {                                            \
-      var [it1] = new type [s2];                 \
-    }
+      var = new type * [s1];                     \
+      for (uint32_t it1=0; it1<s1; ++it1)        \
+        {                                        \
+          var [it1] = new type [s2];             \
+        }                                        \
+    } while (0)
 
 #define ALLOC3(var,type,s1,s2,s3)                \
-  var = new type ** [s1];                        \
-  for (uint32_t it1=0; it1<s1; ++it1)            \
+  do                                             \
     {                                            \
-      var [it1] = new type * [s2];               \
-      for (uint32_t it2=0; it2<s2; ++it2)        \
+      var = new type ** [s1];                    \
+      for (uint32_t it1=0; it1<s1; ++it1)        \
         {                                        \
-          var [it1][it2] = new type [s3];        \
+          var [it1] = new type * [s2];           \
+          for (uint32_t it2=0; it2<s2; ++it2)    \
+            {                                    \
+              var [it1][it2] = new type [s3];    \
+            }                                    \
         }                                        \
-    }
-  
+    } while (0)
+
 #define ALLOC4(var,type,s1,s2,s3,s4)                    \
-  var = new type *** [s1];                              \
-  for (uint32_t it1=0; it1<s1; ++it1)                   \
+  do                                                    \
     {                                                   \
-      var [it1] = new type ** [s2];                     \
-      for (uint32_t it2=0; it2<s2; ++it2)               \
+      var = new type *** [s1];                          \
+      for (uint32_t it1=0; it1<s1; ++it1)               \
         {                                               \
-          var [it1][it2] = new type * [s3];             \
-          for (uint32_t it3=0; it3<s3; ++it3)           \
+          var [it1] = new type ** [s2];                 \
+          for (uint32_t it2=0; it2<s2; ++it2)           \
             {                                           \
-              var [it1][it2][it3] = new type [s4];      \
+              var [it1][it2] = new type * [s3];         \
+              for (uint32_t it3=0; it3<s3; ++it3)       \
+                {                                       \
+                  var [it1][it2][it3] = new type [s4];  \
+                }                                       \
             }                                           \
         }                                               \
-    }
+    } while (0)
 
 #define DELETE0(var)                            \
-  delete var;
-  
-#define DELETE1(var,s1)                          \
-  delete [] var;
-
-#define DELETE2(var,s1,s2)                       \
-  for (uint32_t it1=0; it1<s1; ++it1)            \
+  do                                            \
+    {                                           \
+      delete var;                               \
+    } while (0)
+
+#define DELETE1(var,s1)                         \
+  do                                            \
+    {                                           \
+      delete [] var;                            \
+    } while (0)
+
+#define DELETE2(var,s1,s2)                      \
+  do                                            \
     {                                            \
-      delete [] var [it1];                       \
-    }                                            \
-  delete [] var;                         
-  
+      for (uint32_t it1=0; it1<s1; ++it1)        \
+        {                                        \
+          delete [] var [it1];                   \
+        }                                        \
+      delete [] var;                             \
+    } while (0)
+
 #define DELETE3(var,s1,s2,s3)                    \
-  for (uint32_t it1=0; it1<s1; ++it1)            \
+  do                                             \
     {                                            \
-      for (uint32_t it2=0; it2<s2; ++it2)        \
+      for (uint32_t it1=0; it1<s1; ++it1)        \
         {                                        \
-          delete [] var [it1][it2];              \
+          for (uint32_t it2=0; it2<s2; ++it2)    \
+            {                                    \
+              delete [] var [it1][it2];          \
+            }                                    \
+          delete [] var [it1];                   \
         }                                        \
-      delete [] var [it1];                       \
-    }                                            \
-  delete [] var;
-  
-#define DELETE4(var,s1,s2,s3,s4)                 \
-  for (uint32_t it1=0; it1<s1; ++it1)            \
-    {                                            \
-      for (uint32_t it2=0; it2<s2; ++it2)        \
-        {                                        \
-          for (uint32_t it3=0; it3<s3; ++it3)    \
-            {                                    \
-              delete [] var [it1][it2][it3];     \
-            }                                    \
-          delete [] var [it1][it2];              \
-        }                                        \
-      delete [] var [it1];                       \
-    }                                            \
-  delete [] var;                                        
+      delete [] var;                             \
+    } while (0)
+
+#define DELETE4(var,s1,s2,s3,s4)                        \
+  do                                                    \
+    {                                                   \
+      for (uint32_t it1=0; it1<s1; ++it1)               \
+        {                                               \
+          for (uint32_t it2=0; it2<s2; ++it2)           \
+            {                                           \
+              for (uint32_t it3=0; it3<s3; ++it3)       \
+                {                                       \
+                  delete [] var [it1][it2][it3];        \
+                }                                       \
+              delete [] var [it1][it2];                 \
+            }                                           \
+          delete [] var [it1];                          \
+        }                                               \
+      delete [] var;                                    \
+    } while (0)
 
 // ======================================================================
@@ -108,7 +138,8 @@
 
 #define __ALLOC0_SIGNAL(sig, name, type)        \
-  {                                             \
-    sig = new type (name);                      \
-  }
+  do                                            \
+    {                                           \
+      sig = new type (name);                    \
+    } while (0)
 
 #ifdef POSITION
@@ -125,94 +156,127 @@
 
 #define ALLOC0_VAL_ACK_IN(  sig, name, type)                            \
-  {                                                                     \
-    sig = interface->set_signal_valack_in (name, type);                 \
-  }                                                                     
+  do                                                                    \
+    {                                                                   \
+      sig = interface->set_signal_valack_in (name, type);               \
+    } while (0)
+
 #define ALLOC0_VAL_ACK_OUT( sig, name, type)                            \
-  {                                                                     \
-    sig = interface->set_signal_valack_out(name, type);                 \
-  }                                                                     
+  do                                                                    \
+    {                                                                   \
+      sig = interface->set_signal_valack_out(name, type);               \
+    } while (0)
+                                                                  
 #define ALLOC0_VALACK_IN(     sig, type)                                \
-  {                                                                     \
-    sig = interface->set_signal_valack_in (type);                       \
-  }                                                                     
-#define ALLOC0_VALACK_OUT(    sig, type)                                 \
-  {                                                                     \
-    sig = interface->set_signal_valack_out(type);                       \
-  }                                                                     
-#define ALLOC0_SIGNAL_IN(  sig, name, type, size)                        \
-  if (size > 0)                                                         \
-    {                                                                   \
-      sig = interface->set_signal_in <type> (name, size);               \
-    }                                                                   \
-  else                                                                  \
-    {                                                                   \
-      PRINT_SIZE_NUL(_component,interface,name);                        \
-    }
-  
-#define ALLOC0_SIGNAL_OUT( sig, name, type, size)                        \
-  if (size > 0)                                                         \
-    {                                                                   \
-      sig = interface->set_signal_out<type> (name, size);               \
-    }                                                                   \
-  else                                                                  \
-    {                                                                   \
-      PRINT_SIZE_NUL(_component,interface,name); \
-    }
+  do                                                                    \
+    {                                                                   \
+      sig = interface->set_signal_valack_in (type);                     \
+    } while (0)
+                                                                    
+#define ALLOC0_VALACK_OUT(    sig, type)                                \
+  do                                                                    \
+    {                                                                   \
+      sig = interface->set_signal_valack_out(type);                     \
+    } while (0)
+                                                                     
+#define ALLOC0_SIGNAL_IN(  sig, name, type, size)                       \
+  do                                                                    \
+    {                                                                   \
+      if (size > 0)                                                     \
+        {                                                               \
+          sig = interface->set_signal_in <type> (name, size);           \
+        }                                                               \
+      else                                                              \
+        {                                                               \
+          PRINT_SIZE_NUL(_component,interface,name);                    \
+        }                                                               \
+    } while (0)
+
+#define ALLOC0_SIGNAL_OUT( sig, name, type, size)                       \
+  do                                                                    \
+    {                                                                   \
+      if (size > 0)                                                     \
+        {                                                               \
+          sig = interface->set_signal_out<type> (name, size);           \
+        }                                                               \
+      else                                                              \
+        {                                                               \
+          PRINT_SIZE_NUL(_component,interface,name);                    \
+        }                                                               \
+    } while (0)
 
 #define DELETE0_SIGNAL( sig, size)                                      \
-  if (size > 0)                                                         \
-    {                                                                   \
+  do                                                                    \
+    {                                                                   \
+      if (size > 0)                                                     \
+        {                                                               \
+          delete sig;                                                   \
+        }                                                               \
+    } while (0)
+
+#define ALLOC0_FOREIGN_SIGNAL_IN(  sig, interface, name, type, size)    \
+  do                                                                    \
+    {                                                                   \
+      if (size > 0)                                                     \
+        {                                                               \
+          std::string str = (toString("in")+"_"+((interface!="")?(toString(interface)+"_"):toString(""))+toString(name)); \
+          sig = new SC_IN    (type) (str.c_str());                      \
+        }                                                               \
+    } while (0)
+
+#define ALLOC0_FOREIGN_SIGNAL_OUT( sig, interface, name, type, size)    \
+  do                                                                    \
+    {                                                                   \
+      if (size > 0)                                                     \
+        {                                                               \
+          std::string str = (toString("out")+"_"+((interface!="")?(toString(interface)+"_"):toString(""))+toString(name)); \
+          sig = new SC_OUT   (type) (str.c_str());                      \
+        }                                                               \
+    } while (0)
+
+#define DELETE0_FOREIGN_SIGNAL( sig, size)                              \
+  do                                                                    \
+    {                                                                   \
+      DELETE0_SIGNAL(sig,size);                                         \
+    } while (0)
+
+#define INSTANCE0_FOREIGN_SIGNAL(component, sig, type, name, size)      \
+  do                                                                    \
+    {                                                                   \
+      if (size > 0)                                                     \
+        {                                                               \
+          INSTANCE_FOREIGN_PRINT(name);                                 \
+          _component->set_sc_signal<type>(_name,name,static_cast<void*>(component->sig)); \
+        }                                                               \
+    } while (0)
+
+#define ALLOC0_SC_SIGNAL(  sig, name, type)                             \
+  do                                                                    \
+    {                                                                   \
+      sig = new sc_signal<type> (name);                                 \
+      PRINT_SIGNAL_ADDRESS(name,sig);                                   \
+    } while (0)
+
+#define INSTANCE0_SC_SIGNAL(component, sig)                             \
+  do                                                                    \
+    {                                                                   \
+      TEST_SIGNAL(component->sig->name(),component->sig);               \
+      TEST_SIGNAL(sig           ->name(),sig);                          \
+      (*(component->sig)) (*(sig));                                     \
+    } while (0)
+
+#define _INSTANCE0_SC_SIGNAL(component, sig1,sig2)                      \
+  do                                                                    \
+    {                                                                   \
+      TEST_SIGNAL(component->sig1->name(),component->sig1);             \
+      TEST_SIGNAL(sig2           ->name(),sig2);                        \
+      (*(component->sig1)) (*(sig2));                                   \
+    } while (0)
+
+#define DELETE0_SC_SIGNAL( sig)                                         \
+  do                                                                    \
+    {                                                                   \
+      PRINT_SIGNAL_ADDRESS("",sig);                                     \
       delete sig;                                                       \
-    }
-
-#define ALLOC0_FOREIGN_SIGNAL_IN(  sig, interface, name, type, size)    \
-  if (size > 0)                                                         \
-    {                                                                   \
-      std::string str = (toString("in")+"_"+((interface!="")?(toString(interface)+"_"):toString(""))+toString(name)); \
-      sig = new SC_IN    (type) (str.c_str());                          \
-    }
-
-#define ALLOC0_FOREIGN_SIGNAL_OUT( sig, interface, name, type, size)    \
-  if (size > 0)                                                         \
-    {                                                                   \
-      std::string str = (toString("out")+"_"+((interface!="")?(toString(interface)+"_"):toString(""))+toString(name)); \
-      sig = new SC_OUT   (type) (str.c_str());                          \
-    }
-
-#define DELETE0_FOREIGN_SIGNAL( sig, size) \
-  {                                        \
-    DELETE0_SIGNAL(sig,size);              \
-  }
-
-#define INSTANCE0_FOREIGN_SIGNAL(component, sig, type, name, size)      \
-  if (size > 0)                                                         \
-    {                                                                   \
-      INSTANCE_FOREIGN_PRINT(name);                                     \
-      _component->set_sc_signal<type>(_name,name,static_cast<void*>(component->sig)); \
-    }
-
-#define ALLOC0_SC_SIGNAL(  sig, name, type)                             \
-  sig = new sc_signal<type> (name);                                     \
-  PRINT_SIGNAL_ADDRESS(name,sig);
-
-#define INSTANCE0_SC_SIGNAL(component, sig)                    \
-  {                                                            \
-    TEST_SIGNAL(component->sig->name(),component->sig);        \
-    TEST_SIGNAL(sig           ->name(),sig);                   \
-    (*(component->sig)) (*(sig));                              \
-  }
-
-#define _INSTANCE0_SC_SIGNAL(component, sig1,sig2)                      \
-  {                                                                     \
-    TEST_SIGNAL(component->sig1->name(),component->sig1);               \
-    TEST_SIGNAL(sig2           ->name(),sig2);                          \
-    (*(component->sig1)) (*(sig2));                                     \
-  }
-
-#define DELETE0_SC_SIGNAL( sig)                  \
-  {                                              \
-    PRINT_SIGNAL_ADDRESS("",sig);                \
-    delete sig;                                  \
-  }
+    } while (0)
 
 // ----------------------------------------------------------------------
@@ -220,5 +284,5 @@
 // ----------------------------------------------------------------------
 
-#define __ALLOC1_INTERFACE_BEGIN(name, x1)                                    \
+#define __ALLOC1_INTERFACE_BEGIN(name, x1)                              \
   INTERFACE_PRINT(name);                                                \
   const std::string interface_name = name;                              \
@@ -228,24 +292,27 @@
 
 #define __ALLOC1_SIGNAL_IN( sig, name, type)                            \
-  {                                                                     \
-    sig = new SC_IN(type) * [iterator_1];                               \
-    std::string separator="_";                                          \
-    for (uint32_t it1=0; it1<iterator_1; it1++)                         \
-      {                                                                 \
-        std::string str = "in_"+interface_name+separator+toString(it1)+separator+name; \
-        sig [it1] = new SC_IN(type) (str.c_str());                      \
-      }                                                                 \
-  }
+  do                                                                    \
+    {                                                                   \
+      sig = new SC_IN(type) * [iterator_1];                             \
+      std::string separator="_";                                        \
+      for (uint32_t it1=0; it1<iterator_1; it1++)                       \
+        {                                                               \
+          std::string str = "in_"+interface_name+separator+toString(it1)+separator+name; \
+          sig [it1] = new SC_IN(type) (str.c_str());                    \
+        }                                                               \
+    } while (0)
+
 
 #define __ALLOC1_SIGNAL_OUT( sig, name, type)                           \
-  {                                                                     \
-    sig = new SC_OUT(type) * [iterator_1];                              \
-    std::string separator="_";                                          \
-    for (uint32_t it1=0; it1<iterator_1; it1++)                         \
-      {                                                                 \
-        std::string str = "out_"+interface_name+separator+toString(it1)+separator+name; \
-        sig [it1] = new SC_OUT(type) (str.c_str());                     \
-      }                                                                 \
-  }
+  do                                                                    \
+    {                                                                   \
+      sig = new SC_OUT(type) * [iterator_1];                            \
+      std::string separator="_";                                        \
+      for (uint32_t it1=0; it1<iterator_1; it1++)                       \
+        {                                                               \
+          std::string str = "out_"+interface_name+separator+toString(it1)+separator+name; \
+          sig [it1] = new SC_OUT(type) (str.c_str());                   \
+        }                                                               \
+    } while (0)
 
 #ifdef POSITION
@@ -264,5 +331,5 @@
   }
 #else
-#define ALLOC1_INTERFACE_BEGIN( name, direction, localisation, str, x1)   \
+#define ALLOC1_INTERFACE_BEGIN( name, direction, localisation, str, x1) \
   INTERFACE_PRINT(name);                                                \
   uint32_t iterator_1 = 0;                                              \
